OGR data provider is extemely slow on changing attribute values

2017-02-21 11:54 AM - Martin Landa

Status: Closed

Priority: Normal

Assignee:

Category: Attribute table

Affected QGIS version:2.18.3 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 24126

Description

OGR data provider is extemely slow on changing attribute values. The reason is simple, the method

QgsOgrProvider::changeAttributeValues() doesn't use transactions. The attached sample scripts (qgis.py) shows more than 60sec

elapsed time when changing attribute value for 1000 features stored in SQLite database.

execfile(u'/tmp/tmpMS2K_V.py'.encode('UTF-8'))

Time elapsed: 56.5938699245

Associated revisions

Revision 16a421c7 - 2017-03-15 08:01 AM - Martin Landa

OGR data provider: use transactions when changing attributes and geometries (if possible) (fixes #16216)

Revision 6715441e - 2017-03-20 01:25 PM - Martin Landa

OGR data provider: use transactions when changing attributes and geometries (if possible) (fixes #16216)

Cherry picked from 16a421c7a8292b4e697363e5c57634ff57025e3a

History

#1 - 2017-02-21 11:57 AM - Martin Landa

- File qgis.py added

#2 - 2017-02-21 01:55 PM - Martin Landa

- % Done changed from 0 to 50

See https://github.com/qgis/QGIS/pull/4172

The sample script reports about 1sec when changing 1000 features in SQLite database compared to 60sec without transactions.

#3 - 2017-02-22 02:38 AM - Martin Landa

New pull request against master: https://github.com/qgis/QGIS/pull/4175

2025-05-17 1/2

https://github.com/qgis/QGIS/pull/4172
https://github.com/qgis/QGIS/pull/4175


#4 - 2017-03-14 11:54 PM - Martin Landa

- Status changed from Open to Closed

Fixed in changeset commit:"16a421c7a8292b4e697363e5c57634ff57025e3a".

Files

qgis.py 588 Bytes 2017-02-21 Martin Landa

qgis.py 515 Bytes 2017-02-21 Martin Landa
